/***************************************************************
 * Name:      scroll.h
 * Purpose:   Defines Dialog scroll
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-30
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef SCROLL_H
#define SCROLL_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/validate.h>

class datosScroll
{
    public:
        datosScroll() {}
        datosScroll(int h, int hr, int v, int vr) : horizontal(h), hrango(hr), vertical(v), vrango(vr) {}

    //private:
        int horizontal;
        int hrango;
        int vertical;
        int vrango;
};

class sbValidator : public wxValidator {
public:
    sbValidator(int *v = nullptr) : m_valor(v) {}
    virtual wxObject* Clone() const { return new sbValidator(*this); }
    virtual bool TransferFromWindow();
    virtual bool TransferToWindow();
    virtual bool Validate(wxWindow * parent) { return true; }
private:
    int* m_valor;
    DECLARE_DYNAMIC_CLASS( sbValidator )
    DECLARE_EVENT_TABLE()
};

class scroll : public wxDialog
{
    public:
        scroll(wxWindow *wnd, datosScroll &datos);
        virtual ~scroll();

    protected:
        enum
        {
            idHorizontal = 1000,
            idVertical,
            idTextHorizontal,
            idTextVertical
        };
        datosScroll& data;
        wxScrollBar* m_horizontal;
        wxScrollBar* m_vertical;
        wxStaticText* m_textHorizontal;
        wxStaticText* m_textVertical;

    private:
        void OnClose(wxCloseEvent& event);
        void OnScrollH(wxScrollEvent& event);
        void OnScrollV(wxScrollEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // SCROLL_H
